# os_server_metadata – Add/Update/Delete Metadata in Compute Instances from OpenStack

New in version 2.6.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Add, Update or Remove metadata in compute instances from OpenStack.

## Requirements

The below requirements are needed on the host that executes this module.

- openstack

- openstacksdk >= 0.12.0

- python >= 2.7

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_timeout integer |  | How long should the socket layer wait before timing out for API calls. If this is omitted, nothing will be passed to the requests library.

auth
dictionary

Dictionary containing auth information as needed by the cloud's auth plugin strategy. For the default password plugin, this would contain auth_url, username, password, project_name and any information about domains (for example, os_user_domain_name or os_project_domain_name) if the cloud supports them. For other plugins, this param will need to contain whatever parameters that auth plugin requires. This parameter is not needed if a named cloud is provided or OpenStack OS_* environment variables are present.

auth_type string |  | Name of the auth plugin to use. If the cloud uses something other than password authentication, the name of the plugin should be indicated here and the contents of the auth parameter should be updated accordingly.
availability_zone - |  | Availability zone in which to create the snapshot.
ca_cert string |  | A path to a CA Cert bundle that can be used as part of verifying SSL API requests. aliases: cacert
client_cert string |  | A path to a client certificate to use as part of the SSL transaction. aliases: cert
client_key string |  | A path to a client key to use as part of the SSL transaction. aliases: key

cloud
raw

Named cloud or cloud config to operate against. If cloud is a string, it references a named cloud config as defined in an OpenStack clouds.yaml file. Provides default values for auth and auth_type. This parameter is not needed if auth is provided or if OpenStack OS_* environment variables are present. If cloud is a dict, it contains a complete cloud configuration like would be in a section of clouds.yaml.

interface
string

Choices:
- admin
- internal
- public ←

Endpoint URL type to fetch from the service catalog.
aliases: endpoint_type

meta - / required |  | A list of key value pairs that should be provided as a metadata to the instance or a string containing a list of key-value pairs. Eg: meta: "key1=value1,key2=value2"
region_name string |  | Name of the region.
server - / required |  | Name of the instance to update the metadata aliases: name

state
-

Choices:
- present ←
- absent

Should the resource be present or absent.

timeout integer | Default: 180 | How long should ansible wait for the requested resource.

validate_certs
boolean

Choices:
- no ←
- yes

Whether or not SSL API requests should be verified.
Before Ansible 2.3 this defaulted to `yes`.
aliases: verify

wait
boolean

Choices:
- no
- yes ←

Should ansible wait until the requested resource is complete.

## Notes

Note

- The standard OpenStack environment variables, such as `OS_USERNAME` may be used instead of providing explicit values.

- Auth information is driven by openstacksdk, which means that values can come from a yaml config file in /etc/ansible/openstack.yaml, /etc/openstack/clouds.yaml or ~/.config/openstack/clouds.yaml, then from standard environment variables, then finally by explicit parameters in plays. More information can be found at https://docs.openstack.org/openstacksdk/

## Examples

    # Creates or updates hostname=test1 as metadata of the server instance vm1
    - name: add metadata to compute instance
      hosts: localhost
      tasks:
      - name: add metadata to instance
        os_server_metadata:
            state: present
            auth:
                auth_url: https://openstack-api.example.com:35357/v2.0/
                username: admin
                password: admin
                project_name: admin
            name: vm1
            meta:
                hostname: test1
                group: group1

    # Removes the keys under meta from the instance named vm1
    - name: delete metadata from compute instance
      hosts: localhost
      tasks:
      - name: delete metadata from instance
        os_server_metadata:
            state: absent
            auth:
                auth_url: https://openstack-api.example.com:35357/v2.0/
                username: admin
                password: admin
                project_name: admin
            name: vm1
            meta:
                hostname:
                group:

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
metadata dictionary | success | The metadata of compute instance after the change Sample: {'key1': 'value1', 'key2': 'value2'}
server_id string | success | The compute instance id where the change was made Sample: 324c4e91-3e03-4f62-9a4d-06119a8a8d16

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Mario Santos (@ruizink)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.